#Developed by Alberto Milone (aka tseliot)

import sys
import commands
import string
import os, popen2, fcntl, fcntl, select
from os.path import isfile
import shutil
import classes #instun/classes.py
import interfaceclasses
import objects
import main
import fileinput, re

'''NVIDIA CARDS'''
'''Cards supported by the latest driver'''
def nvnewcards():
    cards = {
        '084a': 'GeForce 8200/ nForce 730a',
        '084b': 'GeForce 8200',
        '084f': 'GeForce 8100 / nForce 720a',
        '0091': 'GeForce 7800 GTX',
        '040e': 'Quadro FX 570',
        '004e': 'Quadro FX 4000',
        '00f6': 'GeForce 6800 GS/XT',
        '060c': 'GeForce 8800M GTX',
        '00f4': 'GeForce 6600 LE',
        '00f5': 'GeForce 7800 GS',
        '00f2': 'GeForce 6600',
        '00f3': 'GeForce 6200',
        '00f0': 'GeForce 6800 Ultra/GeForce 6800',
        '0429': 'Quadro NVS 140M',
        '0426': 'GeForce 8400M GT',
        '0427': 'GeForce 8400M GS',
        '0424': 'GeForce 8400 GS',
        '0425': 'GeForce 8600M GS',
        '033f': 'Quadro FX 700',
        '0423': 'GeForce 8300 GS',
        '00f8': 'Quadro FX 4400/Quadro FX 3400',
        '00f9': 'GeForce 6800 Ultra',
        '0141': 'GeForce 6600',
        '0140': 'GeForce 6600 GT',
        '0143': 'GeForce 6600 VE',
        '0142': 'GeForce 6600 LE',
        '0145': 'GeForce 6610 XL',
        '0144': 'GeForce Go 6600',
        '0147': 'GeForce 6700 XL',
        '0146': 'GeForce Go 6600 TE/6200 TE',
        '0149': 'GeForce Go 6600 GT',
        '0148': 'GeForce Go 6600',
        '0302': 'GeForce FX 5800',
        '0301': 'GeForce FX 5800 Ultra',
        '0048': 'GeForce 6800 XT',
        '0401': 'GeForce 8600 GT',
        '0040': 'GeForce 6800 Ultra',
        '0041': 'GeForce 6800',
        '0042': 'GeForce 6800 LE',
        '0043': 'GeForce 6800 XE',
        '0044': 'GeForce 6800 XT',
        '0045': 'GeForce 6800 GT',
        '0046': 'GeForce 6800 GT',
        '0047': 'GeForce 6800 GS',
        '0600': 'GeForce 8800 GTS 512',
        '0848': 'GeForce 8300',
        '0849': 'GeForce 8200',
        '014a': 'Quadro NVS 440',
        '0531': 'GeForce 7150M / nForce 630M',
        '014c': 'Quadro FX 540M/Quadro FX 540M',
        '0533': 'GeForce 7000M / nForce 610M',
        '014e': 'Quadro FX 540',
        '014d': 'Quadro FX 550',
        '014f': 'GeForce 6200',
        '0611': 'GeForce 8800 GT',
        '00ff': 'GeForce PCX 4300',
        '00fd': 'Quadro NVS 280 PCI-E/Quadro FX 330',
        '00fe': 'Quadro FX 1300',
        '00fb': 'GeForce PCX 5900',
        '00fc': 'Quadro FX 330',
        '00fa': 'GeForce PCX 5750',
        '042f': 'Quadro NVS 290',
        '0333': 'GeForce FX 5950 Ultra',
        '042d': 'Quadro FX 360M',
        '0609': 'GeForce 8800M GTS',
        '042b': 'Quadro NVS 135M',
        '0334': 'GeForce FX 5900ZT',
        '042a': 'Quadro NVS 130M',
        '01d1': 'GeForce 7300 LE',
        '01d0': 'GeForce 7350 LE',
        '01d3': 'GeForce 7300 SE/7200 GS',
        '0326': 'GeForce FX 5500',
        '0321': 'GeForce FX 5200 Ultra',
        '0320': 'GeForce FX 5200',
        '0323': 'eForce FX 5200LE',
        '01d6': 'GeForce Go 7200',
        '01d8': 'GeForce Go 7400',
        '0328': 'GeForce FX Go5200 32M/64M',
        '019d': 'Quadro FX 5600',
        '019e': 'Quadro FX 4600',
        '029a': 'Quadro FX 2500M',
        '0606': 'GeForce 8800 GS',
        '029c': 'Quadro FX 5500',
        '029b': 'Quadro FX 1500M',
        '029e': 'Quadro FX 1500',
        '029d': 'Quadro FX 3500',
        '029f': 'Quadro FX 4500 X2',
        '0332': 'GeForce FX 5900XT',
        '0241': 'GeForce 6150 LE',
        '02e4': 'GeForce 7950 GT',
        '0330': 'GeForce FX 5900 Ultra',
        '0299': 'GeForce Go 7900 GTX',
        '0298': 'GeForce Go 7900 GS',
        '0331': 'GeForce FX 5900',
        '0428': 'GeForce 8400M G',
        '0291': 'GeForce 7900 GT/GTO',
        '0290': 'GeForce 7900 GTX',
        '0293': 'GeForce 7950 GX2',
        '0292': 'GeForce 7900 GS',
        '0295': 'GeForce 7950 GT',
        '0294': 'GeForce 7950 GX2',
        '0297': 'GeForce Go 7950 GTX',
        '0211': 'GeForce 6800',
        '032d': 'GeForce FX Go5100',
        '01dc': 'Quadro FX 350M',
        '0212': 'GeForce 6800 LE',
        '0215': 'GeForce 6800 GT',
        '01dd': 'GeForce 7500 LE',
        '032c': 'GeForce FX Go53xx',
        '01df': 'GeForce 7300 GS',
        '0218': 'GeForce 6800 XT',
        '0191': 'GeForce 8800 GTX',
        '02e1': 'GeForce 7600 GS',
        '0197': 'Tesla C870',
        '0194': 'GeForce 8800 Ultra',
        '02e2': 'GeForce 7300 GS',
        '0422': 'GeForce 8400 GS',
        '0420': 'GeForce 8400 SE',
        '016a': 'GeForce 7100 GS',
        '0421': 'GeForce 8500 GT',
        '0343': 'GeForce FX 5700LE',
        '0342': 'GeForce FX 5700',
        '0341': 'GeForce FX 5700 Ultra',
        '0347': 'GeForce FX Go5700',
        '0344': 'GeForce FX 5700VE',
        '00ce': 'Quadro FX 1400',
        '00cd': 'Quadro FX 3450/4000 SDI',
        '0348': 'GeForce FX Go5700',
        '053b': 'GeForce 7050 PV / NVIDIA nForce 630a',
        '00cc': 'Quadro FX Go1400',
        '06e4': 'GeForce 8400 GS',
        '053e': 'GeForce 7025 / NVIDIA nForce 630a',
        '0242': 'GeForce 6100',
        '0240': 'GeForce 6150',
        '0168': 'GeForce Go 6400',
        '07e0': 'GeForce 7150 / NVIDIA nForce 630i',
        '0309': 'Quadro FX 1000',
        '0244': 'GeForce Go 6150',
        '0245': 'Quadro NVS 210S / NVIDIA GeForce 6150LE',
        '0163': 'GeForce 6200 LE',
        '0162': 'GeForce 6200SE TurboCache(TM)',
        '0161': 'GeForce 6200 TurboCache(TM)',
        '0160': 'GeForce 6500',
        '0167': 'GeForce Go 6200',
        '0166': 'GeForce Go 6400',
        '0165': 'Quadro NVS 285',
        '0164': 'GeForce Go 6200',
        '07e1': 'GeForce 7100 / NVIDIA nForce 630i',
        '060d': 'GeForce 8800 GS',
        '034c': 'Quadro FX Go1000',
        '00c9': 'GeForce Go 6800 Ultra',
        '00c8': 'GeForce Go 6800',
        '034e': 'Quadro FX 1100',
        '00c1': 'GeForce 6800',
        '00c0': 'GeForce 6800 GS',
        '00c3': 'GeForce 6800 XT',
        '00c2': 'GeForce 6800 LE',
        '0394': 'GeForce 7600 LE',
        '0395': 'GeForce 7300 GT',
        '07e3': 'GeForce 7050 / NVIDIA nForce 610i',
        '0397': 'GeForce Go 7700',
        '0390': 'GeForce 7650 GS',
        '0391': 'GeForce 7600 GT',
        '0392': 'GeForce 7600 GS',
        '0393': 'GeForce 7300 GT',
        '061a': 'Quadro FX 3700',
        '0398': 'GeForce Go 7600',
        '0399': 'GeForce Go 7600 GT',
        '03d2': 'GeForce 6100 nForce 400',
        '03d1': 'GeForce 6100 nForce 405',
        '03d0': 'GeForce 6150SE nForce 430',
        '03d5': 'GeForce 6100 nForce 420',
        '0308': 'Quadro FX 2000',
        '0247': 'GeForce Go 6100',
        '0400': 'GeForce 8600 GTS',
        '01da': 'Quadro NVS 110M',
        '0402': 'GeForce 8600 GT',
        '0404': 'GeForce 8400 GS',
        '0602': 'GeForce 8800 GT',
        '0407': 'GeForce 8600M GT',
        '0409': 'GeForce 8700M GT',
        '009d': 'Quadro FX 4500',
        '031a': 'GeForce FX Go5600',
        '031b': 'GeForce FX Go5650',
        '031c': 'Quadro FX Go700',
        '01de': 'Quadro FX 350',
        '01db': 'Quadro NVS 120M',
        '032a': 'Quadro NVS 55/280 PCI',
        '01d7': 'Quadro NVS 110M',
        '00f1': 'GeForce 6600 GT',
        '0325': 'GeForce FX Go5250',
        '0099': 'GeForce Go 7800 GTX',
        '0324': 'GeForce FX Go5200',
        '0169': 'GeForce 6250',
        '0221': 'GeForce 6200',
        '0222': 'GeForce 6200 A-LE',
        '032b': 'Quadro FX 500/FX 600',
        '0327': 'GeForce FX 5100',
        '039e': 'Quadro FX 560',
        '053a': 'GeForce 7050 PV / NVIDIA nForce 630a',
        '0193': 'GeForce 8800 GTS',
        '0338': 'Quadro FX 3000',
        '0322': 'GeForce FX 5200',
        '02e0': 'GeForce 7600 GT/Unknown GPU',
        '040a': 'Quadro FX 370',
        '040b': 'Quadro NVS 320M',
        '040c': 'Quadro FX 570M',
        '040d': 'Quadro FX 1600M',
        '02e3': 'GeForce 7900 GS',
        '040f': 'Quadro FX 1700',
        '0098': 'GeForce Go 7800',
        '0314': 'GeForce FX 5600XT',
        '0095': 'GeForce 7800 SLI',
        '0092': 'GeForce 7800 GTX',
        '0093': 'GeForce 7800 GS',
        '0311': 'GeForce FX 5600 Ultra',
        '0312': 'GeForce FX 5600',
        '0090': 'GeForce 7800 GTX'
    }
    return cards

    '''Cards supported up to driver 96.43.xx'''
def nvmidcards():
    middlecards = {
        '0112': 'GeForce2 Go',
        '0113': 'Quadro2 MXR/EX/Go',
        '0110': 'GeForce2 MX/MX 400',
        '0111': 'GeForce2 MX 100/200',
        '0259': 'Quadro4 750 XGL',
        '0258': 'Quadro4 900 XGL',
        '0179': 'GeForce4 440 Go 64M',
        '0170': 'GeForce4 MX 460',
        '0171': 'GeForce4 MX 440',
        '0172': 'GeForce4 MX 420',
        '0173': 'GeForce4 MX 440-SE',
        '0174': 'GeForce4 440 Go',
        '0175': 'GeForce4 420 Go',
        '0176': 'GeForce4 420 Go 32M',
        '0177': 'GeForce4 460 Go',
        '0185': 'GeForce4 MX 4000',
        '0181': 'GeForce4 MX 440 with AGP8X',
        '0183': 'GeForce4 MX 420 with AGP8X',
        '0182': 'GeForce4 MX 440SE with AGP8X',
        '0286': 'GeForce4 4200 Go',
        '0282': 'GeForce4 Ti 4800 SE',
        '0188': 'Quadro4 580 XGL',
        '0280': 'GeForce4 Ti 4800',
        '0281': 'GeForce4 Ti 4200 with AGP8X',
        '0202': 'GeForce3 Ti 500',
        '0203': 'Quadro DCC',
        '0200': 'GeForce3',
        '0201': 'GeForce3 Ti 200',
        '01f0': 'GeForce4 MX Integrated GPU',
        '0251': 'GeForce4 Ti 4400',
        '0178': 'Quadro4 550 XGL',
        '0250': 'GeForce4 Ti 4600',
        '0253': 'GeForce4 Ti 4200',
        '017a': 'Quadro NVS',
        '017c': 'Quadro4 500 GoGL',
        '017d': 'GeForce4 410 Go 16M',
        '025b': 'Quadro4 700 XGL',
        '0288': 'Quadro4 980 XGL',
        '0289': 'Quadro4 780 XGL',
        '01a0': 'GeForce2 Integrated GPU',
        '018a': 'Quadro NVS 280 SD',
        '018c': 'Quadro NVS 50 PCI',
        '018b': 'Quadro4 380 XGL',
        '028c': 'Quadro4 700 GoGL'
    }
    return middlecards

    '''Cards supported up to driver 71.86.xx aka legacy'''
def nvoldcards():
    legacycards = {
        '0020': 'RIVA TNT',
        '002d': 'RIVA TNT2 Model 64/Model 64 Pro',
        '0028': 'RIVA TNT2/TNT2 Pro',
        '0029': 'RIVA TNT2 Ultra',
        '0101': 'GeForce DDR',
        '0100': 'GeForce 256',
        '0103': 'Quadro',
        '00a0': 'Aladdin TNT2',
        '002c': 'Vanta/Vanta LT',
        '0152': 'GeForce2 Ultra',
        '0153': 'Quadro2 Pro',
        '0150': 'GeForce2 GTS/GeForce2 Pro',
        '0151': 'GeForce2 Ti'
    }
    return legacycards


'''ATI CARDS'''
def atinewcards():
    cards = {
        '72b1': 'ATI RADEON X1650 Series Secondary',
        '4a4f': 'ATI RADEON X800 SE',
        '5568': 'ATI RADEON X800 Series Secondary',
        '712f': 'ATI FireGL V7350 Secondary',
        '718d': 'ATI MOBILITY RADEON X1450',
        '712e': 'ATI FireGL V7300 Secondary',
        '712b': 'ATI RADEON X1800 Series Secondary',
        '712c': 'ATI RADEON X1800 Series Secondary',
        '712a': 'ATI RADEON X1800 Series Secondary',
        '5e6b': 'ATI RADEON X700 PRO Secondary',
        '4a4c': 'ATI RADEON X800 Series',
        '714c': 'ATI MOBILITY RADEON X1300',
        '4a4b': 'ATI RADEON X800 XT',
        '3e70': 'ATI RADEON X600/X550 Series Secondary',
        '4e49': 'ATI RADEON 9800',
        '4e48': 'ATI RADEON 9800 PRO',
        '4167': 'ATI FireGL Z1 Secondary',
        '4149': 'ATI RADEON 9500',
        '4148': 'ATI RADEON 9800 SE',
        '4a49': 'ATI RADEON X800 PRO',
        '71c1': 'ATI RADEON X1650 Series',
        '71de': 'ATI MOBILITY RADEON X1700',
        '71c3': 'ATI RADEON X1300 Series',
        '4146': 'ATI RADEON 9600TX',
        '71c5': 'ATI MOBILITY RADEON X1600',
        '4e44': 'ATI RADEON 9700 PRO',
        '71c7': 'ATI RADEON X1650 Series',
        '4e46': 'ATI RADEON 9600 TX',
        '5974': 'ATI RADEON Xpress Series',
        '7193': 'ATI RADEON X1550 Series',
        '5b63': 'ATI RADEON X300/X550/X1050 Series',
        '7942': 'ATI RADEON Xpress 1200 Series',
        '71a0': 'ATI RADEON X1300/X1550 Series Secondary',
        '7196': 'ATI MOBILITY RADEON X1350',
        '726d': 'ATI RADEON X1900 Series Secondary',
        '4a48': 'ATI RADEON X800 Series',
        '5148': 'ATI FireGL 8800',
        '940b': 'ATI FireGL V8600',
        '5461': 'ATI MOBILITY RADEON X300',
        '5460': 'ATI MOBILITY RADEON X300',
        '5462': 'ATI MOBILITY RADEON X600 SE',
        '5d4f': 'ATI RADEON X800 GTO',
        '5464': 'ATI Mobility FireGL V3100',
        '7128': 'ATI RADEON X1800 Series Secondary',
        '7129': 'ATI RADEON X1800 Series Secondary',
        '72a0': 'ATI RADEON X1950 Series Secondary',
        '4170': 'ATI RADEON 9600 Series Secondary',
        '7124': 'ATI FireGL V7200 Secondary',
        '7125': 'ATI RADEON X1800 Series Secondary',
        '7120': 'ATI RADEON X1800 Series Secondary',
        '4171': 'ATI RADEON 9600 Series Secondary',
        '4172': 'ATI RADEON 9600 Series Secondary',
        '724d': 'ATI RADEON X1900 Series',
        '7181': 'ATI RADEON X1600 Series',
        '719b': 'ATI FireMV 2250',
        '719f': 'ATI RADEON X1550 64-bit',
        '71e2': 'ATI RADEON X1600 Series Secondary',
        '5854': 'ATI RADEON Xpress Series',
        '7162': 'ATI RADEON X1300/X1550 Series Secondary',
        '714e': 'ATI RADEON X1300 Series',
        '71e1': 'ATI RADEON X1650 Series Secondary',
        '5b62': 'ATI RADEON X600 Series',
        '7163': 'ATI RADEON X1550 Series Secondary',
        '4e4a': 'ATI RADEON 9800 XT',
        '71d5': 'ATI MOBILITY RADEON X1700',
        '71d6': 'ATI MOBILITY RADEON X1700 XT',
        '4e4b': 'ATI FireGL X2-256/X2-256t',
        '71ce': 'ATI RADEON X1600 Pro / RADEON X1300 XT',
        '71cd': 'ATI RADEON X1600 Series',
        '71d2': 'ATI FireGL V3400',
        '5d6f': 'ATI RADEON X800 GTO Secondary',
        '4b6a': 'ATI RADEON X850 SE Secondary',
        '4b6b': 'ATI RADEON X850 PRO Secondary',
        '4b6c': 'ATI RADEON X850 XT Platinum Edition Secondary',
        '94c8': 'ATI MOBILITY RADEON HD 2400 XT',
        '94c9': 'ATI MOBILITY RADEON HD 2400',
        '94c7': 'ATI RADEON HD 2350',
        '94c4': 'ATI RADEON HD 2400 PRO AGP',
        '94c5': 'ATI RADEON HD 2400 LE',
        '94c3': 'ATI RADEON HD 2400 PRO',
        '94c1': 'ATI RADEON HD 2400 XT',
        '726b': 'ATI RADEON X1900 Series Secondary',
        '4e68': 'ATI RADEON 9800 PRO Secondary',
        '7247': 'ATI RADEON X1900 Series',
        '7246': 'ATI RADEON X1900 Series',
        '7245': 'ATI RADEON X1900 Series',
        '7244': 'ATI RADEON X1950 Series',
        '7243': 'ATI RADEON X1900 Series',
        '5569': 'ATI RADEON X800 GTO Secondary',
        '7240': 'ATI RADEON X1950 Series',
        '71fa': 'ATI FireGL V5200 Secondary',
        '5e4c': 'ATI RADEON X700 SE',
        '7249': 'ATI RADEON X1900 Series',
        '7248': 'ATI RADEON X1900 Series',
        '4e51': 'ATI RADEON 9600 Series',
        '7187': 'ATI RADEON X1300/X1550 Series',
        '7101': 'ATI MOBILITY RADEON X1800 XT',
        '71e7': 'ATI RADEON X1650 Series Secondary',
        '71e6': 'ATI RADEON X1650 Series Secondary',
        '4a4a': 'ATI RADEON X800 Series',
        '71e3': 'ATI RADEON X1300 Series Secondary',
        '714a': 'ATI MOBILITY RADEON X1300',
        '714b': 'ATI MOBILITY RADEON X1300',
        '71e0': 'ATI RADEON X1600 Series Secondary',
        '3e50': 'ATI RADEON X600/X550 Series',
        '71d4': 'ATI Mobility FireGL V5250',
        '3151': 'ATI FireMV 2400',
        '3150': 'ATI MOBILITY RADEON X600',
        '726c': 'ATI RADEON X1900 Series Secondary',
        '5677': 'ATI RADEON X550/X700 Series Secondary',
        '4b69': 'ATI RADEON X850 XT Secondary',
        '94cb': 'ATI RADEON E2400',
        '94cc': 'ATI RADEON HD 2400',
        '4a6b': 'ATI RADEON X800 XT Secondary',
        '7100': 'ATI RADEON X1800 Series',
        '554a': 'ATI RADEON X800 XT Platinum Edition',
        '7149': 'ATI MOBILITY RADEON X1300',
        '3152': 'ATI MOBILITY RADEON X300',
        '7145': 'ATI MOBILITY RADEON X1400',
        '7146': 'ATI RADEON X1300 / X1550 Series',
        '71ed': 'ATI RADEON X1600 Series Secondary',
        '7140': 'ATI RADEON X1600 Series',
        '7160': 'ATI RADEON X1600 Series Secondary',
        '7142': 'ATI RADEON X1300/X1550 Series',
        '5570': 'ATI FireGL V7100 Secondary',
        '724f': 'ATI RADEON X1900 Series',
        '724e': 'AMD Stream Processor',
        '5673': 'ATI MOBILITY/RADEON X700 Secondary',
        '724c': 'ATI RADEON X1900 Series',
        '724b': 'ATI RADEON X1900 Series',
        '5874': 'ATI RADEON Xpress Series',
        '71c0': 'ATI RADEON X1600 Series',
        '556d': 'ATI RADEON X800 XL Secondary',
        '556e': 'ATI RADEON X800 GT Secondary',
        '5d52': 'ATI RADEON X850 XT',
        '554e': 'ATI RADEON X800 GT',
        '4147': 'ATI FireGL Z1',
        '5975': 'ATI RADEON Xpress Series',
        '5d57': 'ATI RADEON X800 XT',
        '958b': 'Gemini ATI MOBILITY RADEON HD 2600 XT',
        '958c': 'ATI FireGL V5600',
        '72b3': 'ATI RADEON X1650 Series Secondary',
        '71c2': 'ATI RADEON X1600 Series',
        '7106': 'ATI Mobility FireGL V7100',
        '958d': 'ATI FireGL V3600',
        '958e': 'ATI RADEON HD 2600 LE',
        '4e45': 'ATI RADEON 9500 PRO / 9700',
        '4153': 'ATI RADEON 9550/X1050 Series',
        '3154': 'ATI Mobility FireGL V3200',
        '4b4b': 'ATI RADEON X850 PRO',
        '4b4c': 'ATI RADEON X850 XT Platinum Edition',
        '71da': 'ATI FireGL V5200',
        '5a61': 'ATI RADEON Xpress Series',
        '5a62': 'ATI RADEON Xpress Series',
        '5a63': 'ATI RADEON Xpress Series',
        '4e47': 'ATI FireGL X1',
        '726e': 'AMD Stream Processor Secondary',
        '7109': 'ATI RADEON X1800 Series',
        '9400': 'ATI RADEON HD 2900 XT',
        '7260': 'ATI RADEON X1950 Series Secondary',
        '71c6': 'ATI RADEON X1650 Series',
        '7269': 'ATI RADEON X1900 Series Secondary',
        '4a50': 'ATI RADEON X800 XT Platinum Edition',
        '4a6f': 'ATI RADEON X800 SE Secondary',
        '5548': 'ATI RADEON X800 Series',
        '4a6d': 'ATI FireGL X3-256 Secondary',
        '4a6c': 'ATI RADEON X800 Series Secondary',
        '7268': 'ATI RADEON X1900 Series Secondary',
        '4a6a': 'ATI RADEON X800 Series Secondary',
        '4e71': 'ATI RADEON 9600 Series Secondary',
        '7265': 'ATI RADEON X1900 Series Secondary',
        '7264': 'ATI RADEON X1950 Series Secondary',
        '7267': 'ATI RADEON X1900 Series Secondary',
        '7266': 'ATI RADEON X1900 Series Secondary',
        '7153': 'ATI FireGL V3350',
        '5e6a': 'ATI RADEON X700 XT Secondary',
        '7263': 'ATI RADEON X1900 Series Secondary',
        '5e6c': 'ATI RADEON X700 SE Secondary',
        '4a74': 'ATI RADEON X800 VE Secondary',
        '9402': 'ATI RADEON HD 2900 XT',
        '9401': 'ATI RADEON HD 2900 XT',
        '5d48': 'ATI MOBILITY RADEON X800  XT',
        '4a70': 'ATI RADEON X800 XT Platinum Edition Secondary',
        '9405': 'ATI RADEON HD 2900 GT',
        '7108': 'ATI RADEON X1800 Series',
        '5e4b': 'ATI RADEON X700 PRO',
        '716d': 'ATI RADEON X1300 Series Secondary',
        '716e': 'ATI RADEON X1300 Series Secondary',
        '7291': 'ATI RADEON X1650 Series',
        '7293': 'ATI RADEON X1650 Series',
        '566f': 'ATI RADEON X700 Series Secondary',
        '7167': 'ATI RADEON X1550 64-bit Secondary',
        '9501': 'ATI RADEON HD 3870',
        '791f': 'ATI RADEON X1200 Series',
        '791e': 'ATI RADEON X1200 Series',
        '9505': 'ATI RADEON HD 3850',
        '9583': 'ATI MOBILITY RADEON HD 2600 XT',
        '9581': 'ATI MOBILITY RADEON HD 2600',
        '5551': 'ATI FireGL V5100',
        '5550': 'ATI FireGL V7100',
        '4b49': 'ATI RADEON X850 XT',
        '3171': 'ATI FireMV 2400 Secondary',
        '5657': 'ATI RADEON X550/X700 Series',
        '9588': 'ATI RADEON HD 2600 XT',
        '9589': 'ATI RADEON HD 2600 Pro',
        '5652': 'ATI MOBILITY RADEON X700',
        '5653': 'ATI MOBILITY RADEON X700',
        '5e6d': 'ATI RADEON X700 Secondary',
        '4174': 'ATI FireGL T2 Secondary',
        '4175': 'ATI RADEON 9600 Series Secondary',
        '940a': 'ATI FireGL V8650',
        '5d72': 'ATI RADEON X850 XT Secondary',
        '940f': 'ATI FireGL V7600',
        '5d70': 'ATI FireGL V7200 Secondary',
        '4173': 'ATI RADEON 9550/X1050 Series Secondary',
        '7210': 'ATI MOBILITY RADEON HD 2300',
        '7211': 'ATI MOBILITY RADEON HD 2300',
        '5d4a': 'ATI MOBILITY RADEON X800',
        '5d77': 'ATI RADEON X800 XT Secondary',
        '71c4': 'ATI Mobility FireGL V5200',
        '5d4e': 'ATI RADEON X800 GT',
        '5d4d': 'ATI RADEON X850 XT Platinum Edition',
        '5b74': 'ATI FireGL V3100 Secondary',
        '5b75': 'ATI FireMV 2200 Secondary',
        '3e54': 'ATI FireGL V3200',
        '5e68': 'ATI FireGL V5000 Secondary',
        '5d45': 'ATI FireMV 2200 PCI Secondary',
        '5b72': 'ATI RADEON X600 Series Secondary',
        '5b73': 'ATI RADEON X300/X550/X1050 Series Secondary',
        '9586': 'ATI RADEON HD 2600 XT AGP',
        '715f': 'ATI RADEON X1550 64-bit',
        '715e': 'ATI RADEON X1300 Series',
        '726f': 'ATI RADEON X1900 Series Secondary',
        '726a': 'ATI RADEON X1900 Series Secondary',
        '71ee': 'ATI RADEON X1600 Pro / RADEON X1300 XT Secondary',
        '4a69': 'ATI RADEON X800 PRO Secondary',
        '4a68': 'ATI RADEON X800 Series Secondary',
        '5b70': 'ATI RADEON X300/X550/X1050 Series Secondary',
        '710a': 'ATI RADEON X1800 Series',
        '710b': 'ATI RADEON X1800 Series',
        '7280': 'ATI RADEON X1950 Series',
        '710e': 'ATI FireGL V7300',
        '710f': 'ATI FireGL V7350',
        '7284': 'ATI MOBILITY RADEON X1900',
        '5955': 'ATI RADEON Xpress Series',
        '71f2': 'ATI FireGL V3400 Secondary',
        '7288': 'ATI RADEON X1950 GT',
        '554b': 'ATI RADEON X800 GT',
        '71b3': 'ATI RADEON X1550 Series Secondary',
        '7166': 'ATI RADEON X1300 / X1550 Series Secondary',
        '5571': 'ATI FireGL V5100 Secondary',
        '7173': 'ATI FireGL V3350 Secondary',
        '7172': 'ATI FireGL V3300 Secondary',
        '7105': 'ATI RADEON X1800 Series',
        '7143': 'ATI RADEON X1550 Series',
        '5a42': 'ATI RADEON Xpress Series',
        '5a43': 'ATI RADEON Xpress Series',
        '7147': 'ATI RADEON X1550 64-bit',
        '5a41': 'ATI RADEON Xpress Series',
        '71a3': 'ATI RADEON X1300/X1550 Series Secondary',
        '4166': 'ATI RADEON 9600TX Secondary',
        '71a1': 'ATI RADEON X1600 Series Secondary',
        '4164': 'ATI RADEON 9500 Secondary',
        '4e67': 'ATI FireGL X1 Secondary',
        '554d': 'ATI RADEON X800 XL',
        '4e65': 'ATI RADEON 9500 PRO / 9700 Secondary',
        '5954': 'ATI RADEON Xpress Series',
        '4a4e': 'ATI MOBILITY RADEON 9800',
        '4a4d': 'ATI FireGL X3-256',
        '718b': 'ATI MOBILITY RADEON X1350',
        '718c': 'ATI MOBILITY RADEON X1350',
        '5e4f': 'ATI RADEON X700/X550 Series',
        '4e6a': 'ATI RADEON 9800 XT Secondary',
        '5e4d': 'ATI RADEON X700',
        '4168': 'ATI RADEON 9800 SE Secondary',
        '718f': 'ATI RADEON X1300 Series',
        '5b65': 'ATI FireMV 2200',
        '5b64': 'ATI FireGL V3100',
        '5549': 'ATI RADEON X800 GTO',
        '7152': 'ATI FireGL V3300',
        '4a54': 'ATI RADEON X800 VE',
        '5b60': 'ATI RADEON X300/X550/X1050 Series',
        '4e64': 'ATI RADEON 9700 PRO Secondary',
        '714d': 'ATI RADEON X1300 Series',
        '556b': 'ATI RADEON X800 GT Secondary',
        '71bb': 'ATI FireMV 2250 Secondary',
        '5d6d': 'ATI RADEON X850 XT Platinum Edition Secondary',
        '717e': 'ATI RADEON X1300 Series Secondary',
        '5965': 'ATI FireMV 2200 PCI',
        '717f': 'ATI RADEON X1550 64-bit Secondary',
        '724a': 'ATI RADEON X1900 Series',
        '4169': 'ATI RADEON 9500 Secondary',
        '564a': 'ATI Mobility FireGL V5000',
        '564b': 'ATI Mobility FireGL V5000',
        '564f': 'ATI RADEON X700 Series',
        '4b4a': 'ATI RADEON X850 SE',
        '5d50': 'ATI FireGL V7200',
        '7102': 'ATI MOBILITY RADEON X1800',
        '7103': 'ATI Mobility FireGL V7200',
        '7104': 'ATI FireGL V7200',
        '7941': 'ATI RADEON Xpress 1200 Series',
        '4144': 'ATI RADEON 9500',
        '793f': 'ATI RADEON Xpress 1200 Series',
        '5e4a': 'ATI RADEON X700 XT',
        '71a7': 'ATI RADEON X1300/X1550 Series Secondary',
        '9403': 'ATI RADEON HD 2900 PRO',
        '556f': 'ATI RADEON X800 GTO Secondary',
        '4e66': 'ATI RADEON 9600 TX Secondary',
        '4152': 'ATI RADEON 9600 Series',
        '72a8': 'ATI RADEON X1950 GT Secondary',
        '4150': 'ATI RADEON 9600 Series',
        '4151': 'ATI RADEON 9600 Series',
        '554f': 'ATI RADEON X800 GTO',
        '4154': 'ATI FireGL T2',
        '4155': 'ATI RADEON 9600 Series',
        '4e56': 'ATI MOBILITY RADEON 9550',
        '4e54': 'ATI Mobility FireGL T2/T2e',
        '5d49': 'ATI Mobility FireGL V5100',
        '4e52': 'ATI MOBILITY RADEON 9500',
        '5e6f': 'ATI RADEON X700/X550 Series Secondary',
        '4e50': 'ATI MOBILITY RADEON 9600/9700 Series',
        '556a': 'ATI RADEON X800 XT Platinum Edition Secondary',
        '7188': 'ATI MOBILITY RADEON X2300',
        '4e6b': 'ATI FireGL X2-256/X2-256t Secondary',
        '5e48': 'ATI FireGL V5000',
        '5e49': 'ATI FireGL V3300',
        '5d6e': 'ATI RADEON X800 GT Secondary',
        '71af': 'ATI RADEON X1300 Series Secondary',
        '718a': 'ATI MOBILITY RADEON X2300',
        '7180': 'ATI RADEON X1300/X1550 Series',
        '3e74': 'ATI FireGL V3200 Secondary',
        '7183': 'ATI RADEON X1300/X1550 Series',
        '710c': 'ATI RADEON X1800 Series',
        '4e69': 'ATI RADEON 9800 Secondary',
        '7186': 'ATI MOBILITY RADEON X1450',
        '9587': 'ATI RADEON HD 2600 Pro AGP', 
        '9612': 'ATI Radeon HD 3200 Graphics',
        '9613': 'ATI Radeon 3100 Graphics',
        '9610': 'ATI Radeon HD 3200 Graphics',
        '718d': 'ATI Mobility Radeon X1450',
        '9509': 'ATI Mobility Radeon HD 3870 X2',
        '9515': 'ATI Radeon HD 3850 AGP',
        '950f': 'ATI Radeon HD 3870 X2',
        '9599': 'ATI Radeon HD 3600 Series',
        '9598': 'ATI Radeon HD 3600 Series',
        '95c7': 'ATI Radeon HD 3430',
        '9513': 'ATI Radeon HD 3850 X2',
        '95c5': 'ATI Radeon HD 3450',
        '95c4': 'ATI Mobility Radeon HD 3400 Series',
        '9593': 'ATI Mobility Radeon HD 3670',
        '4167': 'ATI FireGL Z1 Secondary',
        '9596': 'ATI Radeon HD 3600 Series',
        '4e67': 'ATI FireGL X1 Secondary',
        '4147': 'ATI FireGL Z1',
        '9611': 'ATI Radeon 3100 Graphics',
        '4e47': 'ATI FireGL X1',
        '95c2': 'ATI Mobility Radeon HD 3430',
        '9590': 'ATI Radeon HD 3600 Series',
        '95c0': 'ATI Radeon HD 3470',
        '9597': 'ATI Radeon HD 3600 Series',
        '9508': 'ATI Mobility Radeon HD 3870',
        '9506': 'ATI Mobility Radeon HD 3850 X2',
        '9507': 'ATI Radeon HD 3830',
        '9504': 'ATI Mobility Radeon HD 3850',
        '9505': 'ATI Radeon HD 3850',
        '94cb': 'ATI Radeon E2400',
        '9591': 'ATI Mobility Radeon HD 3650',
        '9501': 'ATI Radeon HD 3870',
        '7186': 'ATI Mobility Radeon X1450'
    }
    return cards

def atimidcards():#DOESN'T EXIST
    middlecards = {}
    return middlecards

def atioldcards():
    legacycards = {
        '4c6e': 'ATI Mobility / Radeon 9000 Secondary',
        '4c6f': 'ATI Radeon 9000 PRO Secondary',
        '4242': 'ATI Radeon 8500 AIW',
        '514d': 'ATI Radeon 9100 Series',
        '7834': 'ATI Radeon 9000/9100 PRO IGP Series',
        '7835': 'ATI Mobility Radeon 9000 IGP',
        '5942': 'ATI Radeon 9250/9200 Series Secondary',
        '5940': 'ATI Radeon 9250 Secondary',
        '5941': 'ATI Radeon 9250/9200 Series Secondary',
        '514c': 'ATI Radeon 8500 Series',
        '5c63': 'ATI Mobility / Radeon 9200',
        '5c61': 'ATI Mobility / Radeon 9200',
        '5c41': 'ATI Mobility / Radeon 9200 Secondary',
        '5c43': 'ATI Mobility / Radeon 9200 Secondary',
        '5960': 'ATI Radeon 9250',
        '5961': 'ATI Radeon 9250/9200 Series',
        '5962': 'ATI Radeon 9250/9200 Series',
        '5964': 'ATI Radeon 9250/9200 Series',
        '5d44': 'ATI Radeon 9250/9200 Series Secondary',
        '791f': 'ATI Radeon Xpress 1200 Series',
        '791e': 'ATI Radeon Xpress 1200 Series',
        '4967': 'ATI Radeon 9000 Series',
        '4c67': 'ATI Radeon 9000 PRO',
        '4c66': 'ATI Mobility / Radeon 9000',
        '4966': 'ATI Radeon 9000 Series',
        '5834': 'ATI Radeon 9000/9100 IGP Series',
        '5835': 'ATI Mobility Radeon 9000/9100 IGP Series',
        '496f': 'ATI Radeon 9000 Series Secondary',
        '496e': 'ATI Radeon 9000 Series Secondary'
    }
    return legacycards

def atiunsupported():#USELESS
    unsupportedcards = {}
    return unsupportedcards
